"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findFanoutMembershipMintVoucherPda = exports.getFanoutMembershipMintVoucherSize = exports.getFanoutMembershipMintVoucherGpaBuilder = exports.safeFetchAllFanoutMembershipMintVoucher = exports.fetchAllFanoutMembershipMintVoucher = exports.safeFetchFanoutMembershipMintVoucher = exports.fetchFanoutMembershipMintVoucher = exports.deserializeFanoutMembershipMintVoucher = exports.getFanoutMembershipMintVoucherAccountDataSerializer = void 0;
const umi_core_1 = require("@metaplex-foundation/umi-core");
function getFanoutMembershipMintVoucherAccountDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_core_1.mapSerializer)(s.struct([
        ['discriminator', s.array(s.u8(), { size: 8 })],
        ['fanout', s.publicKey()],
        ['fanoutMint', s.publicKey()],
        ['lastInflow', s.u64()],
        ['bumpSeed', s.u8()],
    ], { description: 'FanoutMembershipMintVoucher' }), (value) => ({
        ...value,
        discriminator: [155, 252, 106, 122, 161, 221, 155, 120],
    }));
}
exports.getFanoutMembershipMintVoucherAccountDataSerializer = getFanoutMembershipMintVoucherAccountDataSerializer;
function deserializeFanoutMembershipMintVoucher(context, rawAccount) {
    return (0, umi_core_1.deserializeAccount)(rawAccount, getFanoutMembershipMintVoucherAccountDataSerializer(context));
}
exports.deserializeFanoutMembershipMintVoucher = deserializeFanoutMembershipMintVoucher;
async function fetchFanoutMembershipMintVoucher(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    (0, umi_core_1.assertAccountExists)(maybeAccount, 'FanoutMembershipMintVoucher');
    return deserializeFanoutMembershipMintVoucher(context, maybeAccount);
}
exports.fetchFanoutMembershipMintVoucher = fetchFanoutMembershipMintVoucher;
async function safeFetchFanoutMembershipMintVoucher(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    return maybeAccount.exists
        ? deserializeFanoutMembershipMintVoucher(context, maybeAccount)
        : null;
}
exports.safeFetchFanoutMembershipMintVoucher = safeFetchFanoutMembershipMintVoucher;
async function fetchAllFanoutMembershipMintVoucher(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_core_1.assertAccountExists)(maybeAccount, 'FanoutMembershipMintVoucher');
        return deserializeFanoutMembershipMintVoucher(context, maybeAccount);
    });
}
exports.fetchAllFanoutMembershipMintVoucher = fetchAllFanoutMembershipMintVoucher;
async function safeFetchAllFanoutMembershipMintVoucher(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeFanoutMembershipMintVoucher(context, maybeAccount));
}
exports.safeFetchAllFanoutMembershipMintVoucher = safeFetchAllFanoutMembershipMintVoucher;
function getFanoutMembershipMintVoucherGpaBuilder(context) {
    const s = context.serializer;
    const programId = context.programs.get('mplHydra').publicKey;
    return (0, umi_core_1.gpaBuilder)(context, programId)
        .registerFields([
        ['discriminator', s.array(s.u8(), { size: 8 })],
        ['fanout', s.publicKey()],
        ['fanoutMint', s.publicKey()],
        ['lastInflow', s.u64()],
        ['bumpSeed', s.u8()],
    ])
        .deserializeUsing((account) => deserializeFanoutMembershipMintVoucher(context, account))
        .whereField('discriminator', [155, 252, 106, 122, 161, 221, 155, 120]);
}
exports.getFanoutMembershipMintVoucherGpaBuilder = getFanoutMembershipMintVoucherGpaBuilder;
function getFanoutMembershipMintVoucherSize(_context = {}) {
    return 105;
}
exports.getFanoutMembershipMintVoucherSize = getFanoutMembershipMintVoucherSize;
function findFanoutMembershipMintVoucherPda(context, seeds) {
    const s = context.serializer;
    const programId = context.programs.get('mplHydra').publicKey;
    return context.eddsa.findPda(programId, [
        s.string({ size: 'variable' }).serialize('fanout-membership'),
        s.publicKey().serialize(seeds.fanout),
        s.publicKey().serialize(seeds.membership),
        s.publicKey().serialize(seeds.mint),
    ]);
}
exports.findFanoutMembershipMintVoucherPda = findFanoutMembershipMintVoucherPda;
//# sourceMappingURL=fanoutMembershipMintVoucher.js.map