"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findFanoutMembershipVoucherPda = exports.getFanoutMembershipVoucherSize = exports.getFanoutMembershipVoucherGpaBuilder = exports.safeFetchAllFanoutMembershipVoucher = exports.fetchAllFanoutMembershipVoucher = exports.safeFetchFanoutMembershipVoucher = exports.fetchFanoutMembershipVoucher = exports.deserializeFanoutMembershipVoucher = exports.getFanoutMembershipVoucherAccountDataSerializer = void 0;
const umi_core_1 = require("@metaplex-foundation/umi-core");
function getFanoutMembershipVoucherAccountDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_core_1.mapSerializer)(s.struct([
        ['discriminator', s.array(s.u8(), { size: 8 })],
        ['fanout', s.publicKey()],
        ['totalInflow', s.u64()],
        ['lastInflow', s.u64()],
        ['bumpSeed', s.u8()],
        ['membershipKey', s.publicKey()],
        ['shares', s.u64()],
    ], { description: 'FanoutMembershipVoucher' }), (value) => ({
        ...value,
        discriminator: [16, 229, 84, 210, 96, 22, 126, 120],
    }));
}
exports.getFanoutMembershipVoucherAccountDataSerializer = getFanoutMembershipVoucherAccountDataSerializer;
function deserializeFanoutMembershipVoucher(context, rawAccount) {
    return (0, umi_core_1.deserializeAccount)(rawAccount, getFanoutMembershipVoucherAccountDataSerializer(context));
}
exports.deserializeFanoutMembershipVoucher = deserializeFanoutMembershipVoucher;
async function fetchFanoutMembershipVoucher(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    (0, umi_core_1.assertAccountExists)(maybeAccount, 'FanoutMembershipVoucher');
    return deserializeFanoutMembershipVoucher(context, maybeAccount);
}
exports.fetchFanoutMembershipVoucher = fetchFanoutMembershipVoucher;
async function safeFetchFanoutMembershipVoucher(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    return maybeAccount.exists
        ? deserializeFanoutMembershipVoucher(context, maybeAccount)
        : null;
}
exports.safeFetchFanoutMembershipVoucher = safeFetchFanoutMembershipVoucher;
async function fetchAllFanoutMembershipVoucher(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_core_1.assertAccountExists)(maybeAccount, 'FanoutMembershipVoucher');
        return deserializeFanoutMembershipVoucher(context, maybeAccount);
    });
}
exports.fetchAllFanoutMembershipVoucher = fetchAllFanoutMembershipVoucher;
async function safeFetchAllFanoutMembershipVoucher(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeFanoutMembershipVoucher(context, maybeAccount));
}
exports.safeFetchAllFanoutMembershipVoucher = safeFetchAllFanoutMembershipVoucher;
function getFanoutMembershipVoucherGpaBuilder(context) {
    const s = context.serializer;
    const programId = context.programs.get('mplHydra').publicKey;
    return (0, umi_core_1.gpaBuilder)(context, programId)
        .registerFields([
        ['discriminator', s.array(s.u8(), { size: 8 })],
        ['fanout', s.publicKey()],
        ['totalInflow', s.u64()],
        ['lastInflow', s.u64()],
        ['bumpSeed', s.u8()],
        ['membershipKey', s.publicKey()],
        ['shares', s.u64()],
    ])
        .deserializeUsing((account) => deserializeFanoutMembershipVoucher(context, account))
        .whereField('discriminator', [16, 229, 84, 210, 96, 22, 126, 120]);
}
exports.getFanoutMembershipVoucherGpaBuilder = getFanoutMembershipVoucherGpaBuilder;
function getFanoutMembershipVoucherSize(_context = {}) {
    return 153;
}
exports.getFanoutMembershipVoucherSize = getFanoutMembershipVoucherSize;
function findFanoutMembershipVoucherPda(context, seeds) {
    const s = context.serializer;
    const programId = context.programs.get('mplHydra').publicKey;
    return context.eddsa.findPda(programId, [
        s.string({ size: 'variable' }).serialize('fanout-membership'),
        s.publicKey().serialize(seeds.fanout),
        s.publicKey().serialize(seeds.member),
    ]);
}
exports.findFanoutMembershipVoucherPda = findFanoutMembershipVoucherPda;
//# sourceMappingURL=fanoutMembershipVoucher.js.map