import { Account, Context, Pda, PublicKey, RpcAccount, RpcGetAccountOptions, RpcGetAccountsOptions, Serializer } from '@metaplex-foundation/umi-core';
export type FanoutMint = Account<FanoutMintAccountData>;
export type FanoutMintAccountData = {
    discriminator: Array<number>;
    mint: PublicKey;
    fanout: PublicKey;
    tokenAccount: PublicKey;
    totalInflow: bigint;
    lastSnapshotAmount: bigint;
    bumpSeed: number;
};
export type FanoutMintAccountDataArgs = {
    mint: PublicKey;
    fanout: PublicKey;
    tokenAccount: PublicKey;
    totalInflow: number | bigint;
    lastSnapshotAmount: number | bigint;
    bumpSeed: number;
};
export declare function getFanoutMintAccountDataSerializer(context: Pick<Context, 'serializer'>): Serializer<FanoutMintAccountDataArgs, FanoutMintAccountData>;
export declare function deserializeFanoutMint(context: Pick<Context, 'serializer'>, rawAccount: RpcAccount): FanoutMint;
export declare function fetchFanoutMint(context: Pick<Context, 'rpc' | 'serializer'>, publicKey: PublicKey, options?: RpcGetAccountOptions): Promise<FanoutMint>;
export declare function safeFetchFanoutMint(context: Pick<Context, 'rpc' | 'serializer'>, publicKey: PublicKey, options?: RpcGetAccountOptions): Promise<FanoutMint | null>;
export declare function fetchAllFanoutMint(context: Pick<Context, 'rpc' | 'serializer'>, publicKeys: PublicKey[], options?: RpcGetAccountsOptions): Promise<FanoutMint[]>;
export declare function safeFetchAllFanoutMint(context: Pick<Context, 'rpc' | 'serializer'>, publicKeys: PublicKey[], options?: RpcGetAccountsOptions): Promise<FanoutMint[]>;
export declare function getFanoutMintGpaBuilder(context: Pick<Context, 'rpc' | 'serializer' | 'programs'>): import("@metaplex-foundation/umi-core").GpaBuilder<FanoutMint, {
    discriminator: Array<number>;
    mint: PublicKey;
    fanout: PublicKey;
    tokenAccount: PublicKey;
    totalInflow: number | bigint;
    lastSnapshotAmount: number | bigint;
    bumpSeed: number;
}>;
export declare function getFanoutMintSize(_context?: {}): number;
export declare function findFanoutMintPda(context: Pick<Context, 'eddsa' | 'programs' | 'serializer'>, seeds: {
    fanout: PublicKey;
    mint: PublicKey;
}): Pda;
