"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMplHydraErrorFromName = exports.getMplHydraErrorFromCode = exports.InvalidCloseAccountDestinationError = exports.RemoveSharesMustBeZeroError = exports.RemoveNotSupportedError = exports.TransferNotSupportedError = exports.CannotTransferToSelfError = exports.InvalidStakeAtaError = exports.MustDistributeError = exports.InvalidFanoutForMintError = exports.InsufficientBalanceToDistributeError = exports.NumericalOverflowError = exports.InvalidMetadataError = exports.WalletDoesNotOwnMembershipTokenError = exports.IncorrectOwnerError = exports.DerivedKeyInvalidError = exports.HoldingAccountMustBeAnATAError = exports.InvalidHoldingAccountError = exports.MintDoesNotMatchError = exports.InvalidMembershipVoucherError = exports.InvalidMembershipModelError = exports.MintAccountRequiredError = exports.NewMintAccountRequiredError = exports.SharesArentAtMaxError = exports.InsufficientSharesError = exports.InvalidAuthorityError = exports.BadArtithmeticError = void 0;
const umi_core_1 = require("@metaplex-foundation/umi-core");
const codeToErrorMap = new Map();
const nameToErrorMap = new Map();
class BadArtithmeticError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('Encountered an arithmetic error', program, cause);
        this.name = 'BadArtithmetic';
        this.code = 0x1770;
    }
}
exports.BadArtithmeticError = BadArtithmeticError;
codeToErrorMap.set(0x1770, BadArtithmeticError);
nameToErrorMap.set('BadArtithmetic', BadArtithmeticError);
class InvalidAuthorityError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('Invalid authority', program, cause);
        this.name = 'InvalidAuthority';
        this.code = 0x1771;
    }
}
exports.InvalidAuthorityError = InvalidAuthorityError;
codeToErrorMap.set(0x1771, InvalidAuthorityError);
nameToErrorMap.set('InvalidAuthority', InvalidAuthorityError);
class InsufficientSharesError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('Not Enough Available Shares', program, cause);
        this.name = 'InsufficientShares';
        this.code = 0x1772;
    }
}
exports.InsufficientSharesError = InsufficientSharesError;
codeToErrorMap.set(0x1772, InsufficientSharesError);
nameToErrorMap.set('InsufficientShares', InsufficientSharesError);
class SharesArentAtMaxError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('All available shares must be assigned to a member', program, cause);
        this.name = 'SharesArentAtMax';
        this.code = 0x1773;
    }
}
exports.SharesArentAtMaxError = SharesArentAtMaxError;
codeToErrorMap.set(0x1773, SharesArentAtMaxError);
nameToErrorMap.set('SharesArentAtMax', SharesArentAtMaxError);
class NewMintAccountRequiredError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('A New mint account must be provided', program, cause);
        this.name = 'NewMintAccountRequired';
        this.code = 0x1774;
    }
}
exports.NewMintAccountRequiredError = NewMintAccountRequiredError;
codeToErrorMap.set(0x1774, NewMintAccountRequiredError);
nameToErrorMap.set('NewMintAccountRequired', NewMintAccountRequiredError);
class MintAccountRequiredError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('A Token type Fanout requires a Membership Mint', program, cause);
        this.name = 'MintAccountRequired';
        this.code = 0x1775;
    }
}
exports.MintAccountRequiredError = MintAccountRequiredError;
codeToErrorMap.set(0x1775, MintAccountRequiredError);
nameToErrorMap.set('MintAccountRequired', MintAccountRequiredError);
class InvalidMembershipModelError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('Invalid Membership Model', program, cause);
        this.name = 'InvalidMembershipModel';
        this.code = 0x1776;
    }
}
exports.InvalidMembershipModelError = InvalidMembershipModelError;
codeToErrorMap.set(0x1776, InvalidMembershipModelError);
nameToErrorMap.set('InvalidMembershipModel', InvalidMembershipModelError);
class InvalidMembershipVoucherError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('Invalid Membership Voucher', program, cause);
        this.name = 'InvalidMembershipVoucher';
        this.code = 0x1777;
    }
}
exports.InvalidMembershipVoucherError = InvalidMembershipVoucherError;
codeToErrorMap.set(0x1777, InvalidMembershipVoucherError);
nameToErrorMap.set('InvalidMembershipVoucher', InvalidMembershipVoucherError);
class MintDoesNotMatchError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('Invalid Mint for the config', program, cause);
        this.name = 'MintDoesNotMatch';
        this.code = 0x1778;
    }
}
exports.MintDoesNotMatchError = MintDoesNotMatchError;
codeToErrorMap.set(0x1778, MintDoesNotMatchError);
nameToErrorMap.set('MintDoesNotMatch', MintDoesNotMatchError);
class InvalidHoldingAccountError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('Holding account does not match the config', program, cause);
        this.name = 'InvalidHoldingAccount';
        this.code = 0x1779;
    }
}
exports.InvalidHoldingAccountError = InvalidHoldingAccountError;
codeToErrorMap.set(0x1779, InvalidHoldingAccountError);
nameToErrorMap.set('InvalidHoldingAccount', InvalidHoldingAccountError);
class HoldingAccountMustBeAnATAError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('A Mint holding account must be an ata for the mint owned by the config', program, cause);
        this.name = 'HoldingAccountMustBeAnATA';
        this.code = 0x177a;
    }
}
exports.HoldingAccountMustBeAnATAError = HoldingAccountMustBeAnATAError;
codeToErrorMap.set(0x177a, HoldingAccountMustBeAnATAError);
nameToErrorMap.set('HoldingAccountMustBeAnATA', HoldingAccountMustBeAnATAError);
class DerivedKeyInvalidError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('', program, cause);
        this.name = 'DerivedKeyInvalid';
        this.code = 0x177b;
    }
}
exports.DerivedKeyInvalidError = DerivedKeyInvalidError;
codeToErrorMap.set(0x177b, DerivedKeyInvalidError);
nameToErrorMap.set('DerivedKeyInvalid', DerivedKeyInvalidError);
class IncorrectOwnerError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('', program, cause);
        this.name = 'IncorrectOwner';
        this.code = 0x177c;
    }
}
exports.IncorrectOwnerError = IncorrectOwnerError;
codeToErrorMap.set(0x177c, IncorrectOwnerError);
nameToErrorMap.set('IncorrectOwner', IncorrectOwnerError);
class WalletDoesNotOwnMembershipTokenError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('Wallet Does not Own Membership Token', program, cause);
        this.name = 'WalletDoesNotOwnMembershipToken';
        this.code = 0x177d;
    }
}
exports.WalletDoesNotOwnMembershipTokenError = WalletDoesNotOwnMembershipTokenError;
codeToErrorMap.set(0x177d, WalletDoesNotOwnMembershipTokenError);
nameToErrorMap.set('WalletDoesNotOwnMembershipToken', WalletDoesNotOwnMembershipTokenError);
class InvalidMetadataError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('The Metadata specified is not valid Token Metadata', program, cause);
        this.name = 'InvalidMetadata';
        this.code = 0x177e;
    }
}
exports.InvalidMetadataError = InvalidMetadataError;
codeToErrorMap.set(0x177e, InvalidMetadataError);
nameToErrorMap.set('InvalidMetadata', InvalidMetadataError);
class NumericalOverflowError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('', program, cause);
        this.name = 'NumericalOverflow';
        this.code = 0x177f;
    }
}
exports.NumericalOverflowError = NumericalOverflowError;
codeToErrorMap.set(0x177f, NumericalOverflowError);
nameToErrorMap.set('NumericalOverflow', NumericalOverflowError);
class InsufficientBalanceToDistributeError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('Not enough new balance to distribute', program, cause);
        this.name = 'InsufficientBalanceToDistribute';
        this.code = 0x1780;
    }
}
exports.InsufficientBalanceToDistributeError = InsufficientBalanceToDistributeError;
codeToErrorMap.set(0x1780, InsufficientBalanceToDistributeError);
nameToErrorMap.set('InsufficientBalanceToDistribute', InsufficientBalanceToDistributeError);
class InvalidFanoutForMintError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('', program, cause);
        this.name = 'InvalidFanoutForMint';
        this.code = 0x1781;
    }
}
exports.InvalidFanoutForMintError = InvalidFanoutForMintError;
codeToErrorMap.set(0x1781, InvalidFanoutForMintError);
nameToErrorMap.set('InvalidFanoutForMint', InvalidFanoutForMintError);
class MustDistributeError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('This operation must be the instruction right after a distrobution on the same accounts.', program, cause);
        this.name = 'MustDistribute';
        this.code = 0x1782;
    }
}
exports.MustDistributeError = MustDistributeError;
codeToErrorMap.set(0x1782, MustDistributeError);
nameToErrorMap.set('MustDistribute', MustDistributeError);
class InvalidStakeAtaError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('', program, cause);
        this.name = 'InvalidStakeAta';
        this.code = 0x1783;
    }
}
exports.InvalidStakeAtaError = InvalidStakeAtaError;
codeToErrorMap.set(0x1783, InvalidStakeAtaError);
nameToErrorMap.set('InvalidStakeAta', InvalidStakeAtaError);
class CannotTransferToSelfError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('', program, cause);
        this.name = 'CannotTransferToSelf';
        this.code = 0x1784;
    }
}
exports.CannotTransferToSelfError = CannotTransferToSelfError;
codeToErrorMap.set(0x1784, CannotTransferToSelfError);
nameToErrorMap.set('CannotTransferToSelf', CannotTransferToSelfError);
class TransferNotSupportedError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('Transfer is not supported on this membership model', program, cause);
        this.name = 'TransferNotSupported';
        this.code = 0x1785;
    }
}
exports.TransferNotSupportedError = TransferNotSupportedError;
codeToErrorMap.set(0x1785, TransferNotSupportedError);
nameToErrorMap.set('TransferNotSupported', TransferNotSupportedError);
class RemoveNotSupportedError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('Remove is not supported on this membership model', program, cause);
        this.name = 'RemoveNotSupported';
        this.code = 0x1786;
    }
}
exports.RemoveNotSupportedError = RemoveNotSupportedError;
codeToErrorMap.set(0x1786, RemoveNotSupportedError);
nameToErrorMap.set('RemoveNotSupported', RemoveNotSupportedError);
class RemoveSharesMustBeZeroError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('Before you remove a wallet or NFT member please transfer the shares to another member', program, cause);
        this.name = 'RemoveSharesMustBeZero';
        this.code = 0x1787;
    }
}
exports.RemoveSharesMustBeZeroError = RemoveSharesMustBeZeroError;
codeToErrorMap.set(0x1787, RemoveSharesMustBeZeroError);
nameToErrorMap.set('RemoveSharesMustBeZero', RemoveSharesMustBeZeroError);
class InvalidCloseAccountDestinationError extends umi_core_1.ProgramError {
    constructor(program, cause) {
        super('Sending Sol to a SPL token destination will render the sol unusable', program, cause);
        this.name = 'InvalidCloseAccountDestination';
        this.code = 0x1788;
    }
}
exports.InvalidCloseAccountDestinationError = InvalidCloseAccountDestinationError;
codeToErrorMap.set(0x1788, InvalidCloseAccountDestinationError);
nameToErrorMap.set('InvalidCloseAccountDestination', InvalidCloseAccountDestinationError);
function getMplHydraErrorFromCode(code, program, cause) {
    const constructor = codeToErrorMap.get(code);
    return constructor ? new constructor(program, cause) : null;
}
exports.getMplHydraErrorFromCode = getMplHydraErrorFromCode;
function getMplHydraErrorFromName(name, program, cause) {
    const constructor = nameToErrorMap.get(name);
    return constructor ? new constructor(program, cause) : null;
}
exports.getMplHydraErrorFromName = getMplHydraErrorFromName;
//# sourceMappingURL=mplHydra.js.map