import { Context, PublicKey, Serializer, Signer, WrappedInstruction } from '@metaplex-foundation/umi-core';
export type DistributeNftInstructionAccounts = {
    payer?: Signer;
    member: PublicKey;
    membershipMintTokenAccount: PublicKey;
    membershipKey: PublicKey;
    membershipVoucher: PublicKey;
    fanout: PublicKey;
    holdingAccount: PublicKey;
    fanoutForMint: PublicKey;
    fanoutForMintMembershipVoucher: PublicKey;
    fanoutMint: PublicKey;
    fanoutMintMemberTokenAccount: PublicKey;
    systemProgram?: PublicKey;
    rent?: PublicKey;
    tokenProgram?: PublicKey;
};
export type DistributeNftInstructionData = {
    discriminator: Array<number>;
    distributeForMint: boolean;
};
export type DistributeNftInstructionDataArgs = {
    distributeForMint: boolean;
};
export declare function getDistributeNftInstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<DistributeNftInstructionDataArgs, DistributeNftInstructionData>;
export declare function distributeNft(context: Pick<Context, 'serializer' | 'programs' | 'payer'>, input: DistributeNftInstructionAccounts & DistributeNftInstructionDataArgs): WrappedInstruction;
