import { Context, Pda, PublicKey, Serializer, Signer, WrappedInstruction } from '@metaplex-foundation/umi-core';
import { MembershipModel, MembershipModelArgs } from '../types';
export type InitInstructionAccounts = {
    authority?: Signer;
    fanout?: Pda;
    holdingAccount?: Pda;
    systemProgram?: PublicKey;
    membershipMint?: PublicKey;
    rent?: PublicKey;
    tokenProgram?: PublicKey;
};
export type InitInstructionData = {
    discriminator: Array<number>;
    bumpSeed: number;
    nativeAccountBumpSeed: number;
    name: string;
    totalShares: bigint;
    model: MembershipModel;
};
export type InitInstructionDataArgs = {
    bumpSeed: number;
    nativeAccountBumpSeed: number;
    name: string;
    totalShares: number | bigint;
    model: MembershipModelArgs;
};
export declare function getInitInstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<InitInstructionDataArgs, InitInstructionData>;
export declare function init(context: Pick<Context, 'serializer' | 'programs' | 'eddsa' | 'identity'>, input: InitInstructionAccounts & Omit<InitInstructionDataArgs, 'bumpSeed' | 'nativeAccountBumpSeed'>): WrappedInstruction;
