import { Context, PublicKey, Serializer, Signer, WrappedInstruction } from '@metaplex-foundation/umi-core';
export type InitForMintInstructionAccounts = {
    authority?: Signer;
    fanout: PublicKey;
    fanoutForMint: PublicKey;
    mintHoldingAccount: PublicKey;
    mint: PublicKey;
    systemProgram?: PublicKey;
    rent?: PublicKey;
};
export type InitForMintInstructionData = {
    discriminator: Array<number>;
    bumpSeed: number;
};
export type InitForMintInstructionDataArgs = {
    bumpSeed: number;
};
export declare function getInitForMintInstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<InitForMintInstructionDataArgs, InitForMintInstructionData>;
export declare function initForMint(context: Pick<Context, 'serializer' | 'programs' | 'identity'>, input: InitForMintInstructionAccounts & InitForMintInstructionDataArgs): WrappedInstruction;
