"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setTokenMemberStake = exports.getSetTokenMemberStakeInstructionDataSerializer = void 0;
const umi_core_1 = require("@metaplex-foundation/umi-core");
function getSetTokenMemberStakeInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_core_1.mapSerializer)(s.struct([
        ['discriminator', s.array(s.u8(), { size: 8 })],
        ['shares', s.u64()],
    ], { description: 'SetTokenMemberStakeInstructionArgs' }), (value) => ({
        ...value,
        discriminator: [167, 29, 12, 30, 44, 193, 249, 142],
    }));
}
exports.getSetTokenMemberStakeInstructionDataSerializer = getSetTokenMemberStakeInstructionDataSerializer;
function setTokenMemberStake(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.get('mplHydra').publicKey;
    const memberAccount = input.member;
    const fanoutAccount = input.fanout;
    const membershipVoucherAccount = input.membershipVoucher;
    const membershipMintAccount = input.membershipMint;
    const membershipMintTokenAccountAccount = input.membershipMintTokenAccount;
    const memberStakeAccountAccount = input.memberStakeAccount;
    const systemProgramAccount = input.systemProgram ?? {
        ...context.programs.get('splSystem').publicKey,
        isWritable: false,
    };
    const tokenProgramAccount = input.tokenProgram ?? {
        ...context.programs.get('splToken').publicKey,
        isWritable: false,
    };
    signers.push(memberAccount);
    keys.push({
        pubkey: memberAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_core_1.checkForIsWritableOverride)(memberAccount, true),
    });
    keys.push({
        pubkey: fanoutAccount,
        isSigner: false,
        isWritable: (0, umi_core_1.checkForIsWritableOverride)(fanoutAccount, true),
    });
    keys.push({
        pubkey: membershipVoucherAccount,
        isSigner: false,
        isWritable: (0, umi_core_1.checkForIsWritableOverride)(membershipVoucherAccount, true),
    });
    keys.push({
        pubkey: membershipMintAccount,
        isSigner: false,
        isWritable: (0, umi_core_1.checkForIsWritableOverride)(membershipMintAccount, true),
    });
    keys.push({
        pubkey: membershipMintTokenAccountAccount,
        isSigner: false,
        isWritable: (0, umi_core_1.checkForIsWritableOverride)(membershipMintTokenAccountAccount, true),
    });
    keys.push({
        pubkey: memberStakeAccountAccount,
        isSigner: false,
        isWritable: (0, umi_core_1.checkForIsWritableOverride)(memberStakeAccountAccount, true),
    });
    keys.push({
        pubkey: systemProgramAccount,
        isSigner: false,
        isWritable: (0, umi_core_1.checkForIsWritableOverride)(systemProgramAccount, false),
    });
    keys.push({
        pubkey: tokenProgramAccount,
        isSigner: false,
        isWritable: (0, umi_core_1.checkForIsWritableOverride)(tokenProgramAccount, false),
    });
    const data = getSetTokenMemberStakeInstructionDataSerializer(context).serialize(input);
    const bytesCreatedOnChain = 0;
    return {
        instruction: { keys, programId, data },
        signers,
        bytesCreatedOnChain,
    };
}
exports.setTokenMemberStake = setTokenMemberStake;
//# sourceMappingURL=setTokenMemberStake.js.map