"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.signMetadata = exports.getSignMetadataInstructionDataSerializer = void 0;
const umi_core_1 = require("@metaplex-foundation/umi-core");
function getSignMetadataInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_core_1.mapSerializer)(s.struct([['discriminator', s.array(s.u8(), { size: 8 })]], { description: 'SignMetadataInstructionArgs' }), (value) => ({
        ...value,
        discriminator: [188, 67, 163, 49, 0, 150, 63, 89],
    }));
}
exports.getSignMetadataInstructionDataSerializer = getSignMetadataInstructionDataSerializer;
function signMetadata(context, input) {
    const signers = [];
    const keys = [];
    const programId = context.programs.get('mplHydra').publicKey;
    const authorityAccount = input.authority ?? context.identity;
    const fanoutAccount = input.fanout;
    const holdingAccountAccount = input.holdingAccount;
    const metadataAccount = input.metadata;
    const tokenMetadataProgramAccount = input.tokenMetadataProgram;
    signers.push(authorityAccount);
    keys.push({
        pubkey: authorityAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_core_1.checkForIsWritableOverride)(authorityAccount, true),
    });
    keys.push({
        pubkey: fanoutAccount,
        isSigner: false,
        isWritable: (0, umi_core_1.checkForIsWritableOverride)(fanoutAccount, false),
    });
    keys.push({
        pubkey: holdingAccountAccount,
        isSigner: false,
        isWritable: (0, umi_core_1.checkForIsWritableOverride)(holdingAccountAccount, false),
    });
    keys.push({
        pubkey: metadataAccount,
        isSigner: false,
        isWritable: (0, umi_core_1.checkForIsWritableOverride)(metadataAccount, true),
    });
    keys.push({
        pubkey: tokenMetadataProgramAccount,
        isSigner: false,
        isWritable: (0, umi_core_1.checkForIsWritableOverride)(tokenMetadataProgramAccount, false),
    });
    const data = getSignMetadataInstructionDataSerializer(context).serialize({});
    const bytesCreatedOnChain = 0;
    return {
        instruction: { keys, programId, data },
        signers,
        bytesCreatedOnChain,
    };
}
exports.signMetadata = signMetadata;
//# sourceMappingURL=signMetadata.js.map